/*
 * Copyright (C) 2001-2006 Jacek Sieka, arnetheduck on gmail point com
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#if !defined(ADVANCED_PAGE_H)
#define ADVANCED_PAGE_H

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <atlcrack.h>
#include "PropPage.h"

class AdvancedPage : public CPropertyPage<IDD_ADVANCEDPAGE>, public PropPage
{
public:
	AdvancedPage(SettingsManager *s) : PropPage(s) {
		SetTitle(CTSTRING(SETTINGS_ADVANCED));
		m_psp.dwFlags |= PSP_RTLREADING;
	}

	~AdvancedPage() { }

	BEGIN_MSG_MAP_EX(AdvancedPage)
		MESSAGE_HANDLER(WM_INITDIALOG, onInitDialog)
		COMMAND_HANDLER(IDC_WINAMP_HELP, BN_CLICKED, onClickedWinampHelp)
		COMMAND_HANDLER(IDC_PLAYER_COMBO, CBN_SELCHANGE, onSelChange)
	END_MSG_MAP()

	LRESULT onInitDialog(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	LRESULT onClickedWinampHelp(WORD /* wNotifyCode */, WORD wID, HWND /* hWndCtl */, BOOL& /* bHandled */);	
	LRESULT onSelChange(WORD /* wNotifyCode */, WORD wID, HWND /* hWndCtl */, BOOL& /* bHandled */);

	// Common PropPage interface
	PROPSHEETPAGE *getPSP() { return (PROPSHEETPAGE *)*this; }
	void write();
	
protected:

	static Item items[];
	static TextItem texts[];
	static ListItem listItems[];

	CComboBox ctrlPlayer;
	CEdit ctrlFormat;

	tstring WinampStr;
	tstring WMPlayerStr;
	tstring iTunesStr;
	tstring MPCStr;
	int CurSel;
};

#endif // !defined(ADVANCED_PAGE_H)

/**
 * @file
 * $Id: AdvancedPage.h 308 2007-07-13 18:57:02Z bigmuscle $
 */
